## python3.7 3.7.3

=== debian/changelog ===
python3.7 (3.7.3-2+deb10u7) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * CVE-2023-6597: tempfile.TemporaryDirectory failure to remove dir
  * CVE-2024-0450: quoted-overlap zipbomb DoS

 -- Adrian Bunk <bunk@debian.org>  Sat, 23 Mar 2024 18:12:05 +0200

python3.7 (3.7.3-2+deb10u6) buster-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * CVE-2022-48560: Use-after-free via heappushpop in heapq.
  * CVE-2022-48564: Potential DoS in read_ints in plistlib.py.
  * CVE-2022-48565: Avoid XML External Entity (XXE) issues by rejecting
    entity declarations in XML plist files in plistlib.
  * CVE-2022-48566: Avoid some possible constant-time-defeating compiler
    optimisations in the accumulator variable in hmac.compare_digest.
  * CVE-2023-40217: Fix possible bypass of some of the protections
    implemented by the TLS handshake in ssl.SSLSocket class.
    - Also apply two upstream commits to stabilise the test suite.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 11 Oct 2023 10:51:27 +0100

python3.7 (3.7.3-2+deb10u5) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * CVE-2015-20107: The mailcap module did not add escape characters
    into commands discovered in the system mailcap file.
  * CVE-2020-10735: Prevent DoS with very large int.
  * CVE-2021-3426: Remove the pydoc getfile feature which
    could be abused to read arbitrary files on the disk.
  * CVE-2021-3733: Regular Expression Denial of Service in urllib's
    AbstractBasicAuthHandler class.
  * CVE-2021-3737: Infinite loop in the HTTP client code.
  * CVE-2021-4189: Make ftplib not trust the PASV response.
  * CVE-2022-45061: Quadratic time in the IDNA decoder.

 -- Adrian Bunk <bunk@debian.org>  Thu, 29 Jun 2023 21:03:57 +0300

python3.7 (3.7.3-2+deb10u4) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * Resolve CVE-2022-37454, a buffer overflow it the SHA-3 implementation in
    the _sha3 (and thus hashlib) module.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 31 Oct 2022 16:04:00 +0200

python3.7 (3.7.3-2+deb10u3) buster; urgency=medium

  * CVE-2020-26116
  * CVE-2021-3177

 -- Moritz Mühlenhoff <jmm@debian.org>  Fri, 22 Jan 2021 21:04:44 +0100

python3.7 (3.7.3-2+deb10u2) buster; urgency=medium

  * CVE-2019-20907
  * CVE-2020-14422
  * CVE-2020-8492

 -- Moritz Mühlenhoff <jmm@debian.org>  Sat, 25 Jul 2020 15:03:44 +0200

python3.7 (3.7.3-2+deb10u1) buster; urgency=medium

  * CVE-2019-9740
  * CVE-2019-9947
  * CVE-2019-9948
  * CVE-2019-10160
  * CVE-2019-16056
  * CVE-2019-16935

 -- Moritz Mühlenhoff <jmm@debian.org>  Fri, 20 Dec 2019 19:57:59 +0100

python3.7 (3.7.3-2) unstable; urgency=medium

  * d/p/arm-alignment.diff: Don't allow unaligned memory accesses in the
    _sha3 extension (Dave Jones). LP: #1821869. Issue #36515.
  * Tweak the asyncio/ssl test again.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Apr 2019 07:39:12 +0200

python3.7 (3.7.3-1) unstable; urgency=medium

  * Python 3.7.3 release.
  * Work around issue #35988, reducing the payload size for the asyncio/ssl
    tests.

 -- Matthias Klose <doko@debian.org>  Tue, 26 Mar 2019 08:25:18 +0100

python3.7 (3.7.3~rc1-1) unstable; urgency=medium

  * Python 3.7.3 release candidate 1.
  * CVE-2019-9636. Fix issue #36216: Add check for characters in netloc that
    normalize to separators. Closes: #924072.
  * Use a build profile for libbluetooth-dev (<!pkg.python3.7.nobluetooth>).

 -- Matthias Klose <doko@debian.org>  Wed, 13 Mar 2019 12:01:15 +0100

python3.7 (3.7.2-3) unstable; urgency=medium

  * Update to 20190227 from the 3.7 branch.
  * Add more breaks for packages not compatible with Python 3.7:
    - xapers. Closes: #916914.
  * Move the test/ann_module{,2,3} modules into libpython-stdlib.
    Closes: #922285.
  * Limit the import checks for some extension modules to native builds.
    Closes: #921742.

 -- Matthias Klose <doko@debian.org>  Wed, 27 Feb 2019 16:41:59 +0100

python3.7 (3.7.2-2) unstable; urgency=medium

  * Update to 20190202 from the 3.7 branch.

 -- Matthias Klose <doko@debian.org>  Sat, 02 Feb 2019 15:31:48 +0100

python3.7 (3.7.2-1) unstable; urgency=medium

  * Python 3.7.2 release.
  * Revert the link optimization changes which appeared after the
    release candidate.
  * Make the build compatible with sphinx 1.6.x.
  * Loosen the pyzo break. Closes: #916548.

 -- Matthias Klose <doko@debian.org>  Thu, 03 Jan 2019 03:55:40 +0100

python3.7 (3.7.2~rc1-1) unstable; urgency=medium

  * Python 3.7.2 release candidate 1.
  * Add more breaks for packages not compatible with Python 3.7:
    - python3-dns. Closes: #912988.
    - python3-dkim. Closes: #912084.
    - pyzo. Closes: #914332.
  * Update VCS attributes. Closes: #904097.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Wed, 12 Dec 2018 07:25:49 +0100

=== debian/control ===
Source: python3.7
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.4),
  libbluetooth-dev [linux-any] <!pkg.python3.7.nobluetooth>,
  locales-all,
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  mime-support, netbase, bzip2, time, python3:any,
  net-tools, xvfb, xauth
Build-Depends-Indep: python3-sphinx, texinfo
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/cpython-team/python3/tree/python3.7
Vcs-Git: https://salsa.debian.org/cpython-team/python3.git -b python3.7
XS-Testsuite: autopkgtest

Package: python3.7
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.7-minimal (= ${binary:Version}),
 libpython3.7-stdlib (= ${binary:Version}),
 mime-support,
 ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.7-venv, python3.7-doc, binutils
Breaks: python3-all (<< 3.6.5~rc1-1),
  python3-dev (<< 3.6.5~rc1-1),
  python3-venv (<< 3.6.5-2), ${python37:Breaks}
Description: Interactive high-level object-oriented language (version 3.7)
 Python is a high-level, interactive, object-oriented language. Its 3.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.7-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.7 (= ${binary:Version}),
 python-pip-whl (>= 8.1.0-2), ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.7)
 Python is a high-level, interactive, object-oriented language. Its 3.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.7 binary.

Package: libpython3.7-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.7-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-tk (<< 3.6.4~rc1-2), libmpdec2 (<< 2.4.2),
  python3-distutils (<< 3.6.5~rc1-2),
  libpython3.7-testsuite (<< 3.7.2-3),
Replaces: python3-distutils (<< 3.6.5~rc1-2), libpython3.7-testsuite (<< 3.7.2-3),
Description: Interactive high-level object-oriented language (standard library, version 3.7)
 Python is a high-level, interactive, object-oriented language. Its 3.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.7's standard library. It is normally not
 used on its own, but as a dependency of python3.7.

Package: python3.7-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.7-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.7
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.7)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.7-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython3.7-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.7-stdlib
Breaks: libpython3.7-stdlib (<< 3.7.0~b2-1~)
Conflicts: binfmt-support (<< 1.1.2), libpython3.7-stdlib (<< 3.7.0~b2-1~)
Description: Minimal subset of the Python language (version 3.7)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.7-minimal.

Package: libpython3.7
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.7-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.7)
 Python is a high-level, interactive, object-oriented language. Its 3.7 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.7-examples
Architecture: all
Depends: python3.7 (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.7)
 Examples, Demos and Tools for Python (v3.7). These are files included in
 the upstream Python distribution (v3.7).

Package: python3.7-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.7 (= ${binary:Version}), libpython3.7-dev (= ${binary:Version}), libpython3.7 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.7)
 Header files, a static library and development tools for building
 Python (v3.7) modules, extending the Python interpreter or embedding
 Python (v3.7) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.7-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.7-stdlib (= ${binary:Version}), libpython3.7 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.7)
 Header files, a static library and development tools for building
 Python (v3.7) modules, extending the Python interpreter or embedding
 Python (v3.7) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.7-dev.

Package: libpython3.7-testsuite
Section: libdevel
Architecture: all
Depends: python3.7 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.7)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.7-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.7-stdlib package).

Package: idle-python3.7
Architecture: all
Depends: python3.7, python3-tk, python3.7-tk, ${misc:Depends}
Enhances: python3.7
Breaks: libpython3.7-stdlib (<< 3.7.0~a3-1)
Replaces: libpython3.7-stdlib (<< 3.7.0~a3-1)
Description: IDE for Python (v3.7) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.7).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.7-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.7
Description: Documentation for the high-level object-oriented language Python (v3.7)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.7). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.7
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.7-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.7 (= ${binary:Version}), libpython3.7-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.7)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.7-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.7-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug Build of the Python Interpreter (version 3.7)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export DEB_BUILD_MAINT_OPTIONS=hardening=-pie
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative      := $(shell \
	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
	elif dpkg-vendor --derives-from Debian; then echo Debian; \
	else echo Unknown; fi)

VER=3.7
SVER=3.7.0
NVER=3.8
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++
ifneq (,$(filter $(distrelease),bionic))
  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
  bd_gcc = g++-8,
endif

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

# on ia64, disable -O3 until gcc bug #85412 is fixed
ifeq ($(DEB_HOST_ARCH),ia64)
    EXTRA_OPT_CFLAGS += -O2
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

sysconfig_substflags = \
	-e 's,gcc-8,gcc,;s,g++-8,g++,' \
	-e '/^OPT/s,-O3,-O2,' \
	-e 's/-O3/-O2/g;s/$(LTO_CFLAGS)//g' \
	-e 's/-fprofile-use *-fprofile-correction//g' \
	-e 's/-fstack-protector /-fstack-protector-strong /g' \
	-e 's/-specs=[^ ]*//g' \
	-e 's/-fdebug-prefix-map=[^ ]*//g' \
	-e 's,^RUNSHARED *=.*,RUNSHARED=,' \
	-e '/BLDLIBRARY/s/-L\. //'

ifeq ($(derivative),Ubuntu)
  arch_substvars =
else ifeq ($(derivative),Debian)
  arch_substvars =  '-Vpython37:Breaks=$(shell tr '\n' ' ' < debian/py37-breaks.$(derivative))'
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg
p_udeb	:= $(PVER)-udeb
p_venv	:= $(PVER)-venv

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev
p_ldbg	:= lib$(PVER)-dbg

## python3.7 3.7.3.11

=== debian/changelog ===
python3.7 (3.7.3.11-1+dde) unstable; urgency=medium

  * fix CVE-2022-0391

 -- Ding Heng <dingheng@uniontech.com>  Wed, 09 Mar 2022 11:38:16 +0800

python3.7 (3.7.3.10-1+dde) unstable; urgency=medium

  * 升级版本去掉产品标识eagle

 -- XiaoBo <xiaobo@uniontech.com>  Thu, 30 Dec 2021 13:42:57 +0800

python3.7 (3.7.3.9-1+eagle) unstable; urgency=medium

  * add loongarch64 support
    [config.guess]

 -- Angie.J <doucaixia@uniontech.com>  Sat, 06 Nov 2021 18:06:13 +0800

python3.7 (3.7.3.8-1+eagle) unstable; urgency=medium

  * add loongarch64 support
    [configure.ac]
    [debian/{rules,libpython.symbols.in,multiarch.h.in}] 

 -- Angie.J <doucaixia@uniontech.com>  Thu, 16 Sep 2021 16:57:23 +0800

python3.7 (3.7.3.7-1+eagle) unstable; urgency=medium

  * uos sw64 porting

 -- zhangfeilong <zhangfeilong@uniontech.com>  Wed, 14 Apr 2021 23:02:43 +0000

python3.7 (3.7.3.6-1+eagle) unstable; urgency=medium

  * debian 10.9 update
  * update to debian/3.7.3-2+deb10u3

 -- caihouhui <caihouhui@uniontech.com>  Fri, 02 Apr 2021 10:58:59 +0800

python3.7 (3.7.3.5-1+security) buster; urgency=medium

  * fix CVE-2021-23336

 -- zhouzilong <zhouzilong@uniontech.com>  Thu, 01 Apr 2021 21:23:21 +0800

python3.7 (3.7.3.4-1+eagle) buster; urgency=medium

  * fix CVE-2021-3177

 -- zhouzilong <zhouzilong@uniontech.com>  Fri, 26 Feb 2021 10:58:02 +0800

python3.7 (3.7.3.3-1+dde) buster; urgency=medium

  * Fix CVE-2020-27619

 -- zhouzilong <zhouzilong@uniontech.com>  Fri, 27 Nov 2020 17:10:57 +0800

python3.7 (3.7.3.2-1+dde) buster; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2020-26116

 -- zhouzilong <zhouzilong@uniontech.com>  Wed, 28 Oct 2020 13:43:56 +0800

python3.7 (3.7.3.1-2+deb10u2) buster; urgency=medium

  * CVE-2019-20907
  * CVE-2020-14422
  * CVE-2020-8492

 -- Moritz Mühlenhoff <jmm@debian.org>  Sat, 25 Jul 2020 15:03:44 +0200

## python3.7 3.7.3.13

=== debian/changelog ===
python3.7 (3.7.3.13-1+dde) unstable; urgency=medium

  * fix CVE-2021-3426

 -- Ding Heng <dingheng@uniontech.com>  Sun, 09 Oct 2022 17:38:23 +0800

python3.7 (3.7.3.12-1+dde) unstable; urgency=medium

  * fix CVE-2021-3733 CVE-2021-3737.
  * 

 -- liaoyuan <liaoyuan@uniontech.com>  Sat, 08 Oct 2022 11:03:56 +0800

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,11 @@
 DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
 DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)
 
+ifeq ($(DEB_HOST_ARCH),sw_64)
+DEB_BUILD_OPTIONS += nocheck
+DEB_BUILD_OPTIONS += nobench
+endif
+
 ifeq ($(DEB_HOST_ARCH_OS),linux)
   PLAT = linux
 else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
@@ -57,10 +62,10 @@
   WITHOUT_BENCH := yes
 endif
 ifeq ($(on_buildd),yes)
-  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
+  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa loongarch64 mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
     WITHOUT_CHECK := yes
   endif
-  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
+  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa loongarch64 mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
     WITHOUT_BENCH := yes
   endif
 endif
@@ -150,8 +155,13 @@
   bd_gcc = g++-8,
 endif
 
+ifeq ($(DEB_HOST_ARCH),sw_64)
+AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
+RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
+else
 AR=$(DEB_HOST_GNU_TYPE)-ar
 RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib
+endif
 
 DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
 DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
@@ -236,13 +246,3 @@
 p_tk	:= $(PVER)-tk
 p_dev	:= $(PVER)-dev
 p_exam	:= $(PVER)-examples
-p_idle	:= idle-$(PVER)
-p_doc	:= $(PVER)-doc
-p_dbg	:= $(PVER)-dbg
-p_udeb	:= $(PVER)-udeb
-p_venv	:= $(PVER)-venv
-
-p_lbase	:= lib$(PVER)-stdlib
-p_lmin	:= lib$(PVER)-minimal
-p_ldev	:= lib$(PVER)-dev
-p_ldbg	:= lib$(PVER)-dbg

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential,
  locales-all,
  python3.7-dev,
  libpython3.7-testsuite,
  python3-gdbm,
  python3-distutils,
  python3-tk,
  idle-python3.7,
# need to turn off apport
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential,
  locales-all, python3.7-dev,
  python3.7-dbg,
  libpython3.7-testsuite,
  python3-gdbm-dbg,
  gdb,
  python3-distutils,
  python3-tk-dbg,
  idle-python3.7,
# need to turn off apport
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential,
  locales-all,
  python3.7-dev,
  libpython3.7-testsuite,
  python3-gdbm,
  python3-distutils,
# need to turn off apport
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential,
  locales-all,
  python3.7-dev,
  python3.7-dbg,
  libpython3.7-testsuite,
  python3-gdbm-dbg,
  gdb,
  python3-distutils,
# need to turn off apport
Restrictions: needs-root allow-stderr

=== debian/watch ===
version=3
opts=dversionmangle=s/.*\+//,uversionmangle=s/([abcr]+[1-9])$/~$1/ \
  http://www.python.org/ftp/python/3\.7(\.\d)?/Python-(3\.7[.\dabcr]*)\.tgz

## python3.7 3.7.3.14

=== debian/changelog ===
python3.7 (3.7.3.14-1+dde) unstable; urgency=medium

  * fix CVE-2022-37454

 -- wangjia <wangjia@uniontech.com>  Tue, 01 Nov 2022 18:27:39 +0800

## python3.7 3.7.5~rc1

=== debian/changelog ===
python3.7 (3.7.5~rc1-2) unstable; urgency=medium

  * Apply proposed patch for issue 38368. LP: #1847036. Closes: #941650.

 -- Matthias Klose <doko@debian.org>  Tue, 08 Oct 2019 18:47:45 +0200

python3.7 (3.7.5~rc1-1) unstable; urgency=medium

  * Python 3.7.5 release candidate 1.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 02 Oct 2019 06:19:31 +0200

python3.7 (3.7.4-4) unstable; urgency=medium

  * Update to 20190904 from the 3.7 branch.

 -- Matthias Klose <doko@debian.org>  Wed, 04 Sep 2019 10:03:05 +0200

python3.7 (3.7.4-3) unstable; urgency=medium

  * Enable pgo/lto builds on arm64. Closes: #934812.
  * Don't propagate lto flags to the _sysconfigdata module. Closes: #934771.
  * d/patches/issue35998.diff: Disable TLS1.3 in the client on all platforms
    rather than just reducing the payload size (Michael Hudson-Doyle).
  * Annote build dependencies used for tests. Closes: #928513.

 -- Matthias Klose <doko@debian.org>  Wed, 21 Aug 2019 18:01:23 +0200

python3.7 (3.7.4-2) unstable; urgency=medium

  * Bump the platform name for KFreeBSD.

 -- Matthias Klose <doko@debian.org>  Thu, 11 Jul 2019 12:43:21 +0200

python3.7 (3.7.4-1) unstable; urgency=medium

  * Python 3.7.4 release.

 -- Matthias Klose <doko@debian.org>  Tue, 09 Jul 2019 07:48:37 +0200

python3.7 (3.7.4~rc2-2) unstable; urgency=medium

  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Mon, 08 Jul 2019 12:07:13 +0200

python3.7 (3.7.4~rc2-1) experimental; urgency=medium

  * Python 3.7.4 release candidate 2.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Jul 2019 09:09:05 +0200

python3.7 (3.7.4~rc1-1) experimental; urgency=medium

  * Python 3.7.4 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Wed, 19 Jun 2019 19:04:25 +0200

python3.7 (3.7.1-1~18.10) cosmic-proposed; urgency=medium

  * SRU: LP: #1799202.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Oct 2018 13:21:55 +0200

=== debian/control ===
--- 
+++ 
@@ -15,9 +15,9 @@
   libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
   libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
   mime-support, netbase, bzip2, time, python3:any,
-  net-tools, xvfb, xauth
+  net-tools, xvfb <!nocheck>, xauth <!nocheck>
 Build-Depends-Indep: python3-sphinx, texinfo
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/cpython-team/python3/tree/python3.7
 Vcs-Git: https://salsa.debian.org/cpython-team/python3.git -b python3.7
 XS-Testsuite: autopkgtest

=== debian/rules ===
--- 
+++ 
@@ -21,15 +21,10 @@
 DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
 DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)
 
-ifeq ($(DEB_HOST_ARCH),sw_64)
-DEB_BUILD_OPTIONS += nocheck
-DEB_BUILD_OPTIONS += nobench
-endif
-
 ifeq ($(DEB_HOST_ARCH_OS),linux)
   PLAT = linux
 else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
-  PLAT = gnukfreebsd10
+  PLAT = gnukfreebsd11
 else ifeq ($(DEB_HOST_ARCH_OS),hurd)
   PLAT = gnu0
 else
@@ -62,10 +57,10 @@
   WITHOUT_BENCH := yes
 endif
 ifeq ($(on_buildd),yes)
-  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa loongarch64 mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
+  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
     WITHOUT_CHECK := yes
   endif
-  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa loongarch64 mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
+  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
     WITHOUT_BENCH := yes
   endif
 endif
@@ -155,13 +150,8 @@
   bd_gcc = g++-8,
 endif
 
-ifeq ($(DEB_HOST_ARCH),sw_64)
-AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
-RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
-else
 AR=$(DEB_HOST_GNU_TYPE)-ar
 RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib
-endif
 
 DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
 DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
@@ -181,13 +171,13 @@
 
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
   ifeq ($(DEB_HOST_ARCH_OS),linux)
-    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
+    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
       with_pgo := yes
     endif
   endif
 endif
 
-ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
+ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
   with_lto := yes
 endif
 
@@ -198,8 +188,9 @@
     with_lto =
 endif
 
+BASE_LTO_CFLAGS = -g -fwrapv -O3
 ifeq ($(with_lto),yes)
-    LTO_CFLAGS = -g -flto -fuse-linker-plugin
+    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin
     with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
 			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
     ifeq ($(with_fat_lto),yes)
@@ -212,8 +203,9 @@
 
 sysconfig_substflags = \
 	-e 's,gcc-8,gcc,;s,g++-8,g++,' \
+	$(if $(with_lto),$(foreach i,-flto -fuse-linker-plugin -ffat-lto-objects,-e 's/$(i)//g')) \
 	-e '/^OPT/s,-O3,-O2,' \
-	-e 's/-O3/-O2/g;s/$(LTO_CFLAGS)//g' \
+	-e 's/-O3/-O2/g' \
 	-e 's/-fprofile-use *-fprofile-correction//g' \
 	-e 's/-fstack-protector /-fstack-protector-strong /g' \
 	-e 's/-specs=[^ ]*//g' \
@@ -246,3 +238,7 @@
 p_tk	:= $(PVER)-tk
 p_dev	:= $(PVER)-dev
 p_exam	:= $(PVER)-examples
+p_idle	:= idle-$(PVER)
+p_doc	:= $(PVER)-doc
+p_dbg	:= $(PVER)-dbg
+p_udeb	:= $(PVER)-udeb

## python3.7 3.7.5

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
VENVDIR      = ./venv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)

# Internal variables.
PAPEROPT_a4     = -D latex_elements.papersize=a4paper
PAPEROPT_letter = -D latex_elements.papersize=letterpaper

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees $(PAPEROPT_$(PAPER)) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable venv

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif [ -d ../Misc/NEWS.d ]; then \
		echo "Building NEWS from Misc/NEWS.d with blurb"; \
		$(BLURB) merge -f build/NEWS; \
	else \
		echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/* $(VENVDIR)/*

venv:
	$(PYTHON) -m venv $(VENVDIR)
	$(VENVDIR)/bin/python3 -m pip install -U Sphinx blurb
	@echo "The venv has been created in the $(VENVDIR) directory"

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

check:
	$(PYTHON) tools/rstlint.py -i tools -i $(VENVDIR) -i README.rst

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build
# By default, Sphinx only rebuilds pages where the page content has changed.
# This means it doesn't always pick up changes to preferred link targets, etc
# To ensure such changes are picked up, we build the published docs with
# `-E` (to ignore the cached environment) and `-a` (to ignore already existing
# output files)

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1 -A switchers=1'
	-make suspicious

# for quick rebuilds (HTML only)
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1 -A switchers=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

=== debian/changelog ===
python3.7 (3.7.5-2ubuntu1~18.04.2) bionic-security; urgency=medium

  * SECURITY UPDATE: Regular Expression Denial of Service
    - debian/patches/CVE-2020-8492.patch: updates a regular expression in the 
      urllib.request.AbsatrctBasicAuthHandler class which allows for 
      catastrophic backtracking and could result in a Denial of Service 
      condition.
    - CVE-2020-8492 
  * SECURITY UPDATE: Regular Expression Denial of Service
    - debian/patches/CVE-2021-3733.patch: updates a regular expression in the 
      urllib.request.AbstractBasicAuthHandler class which has a quadratic
      worst-case time complexity and could be abused by a malicious HTTP
      server to cause a Denial of Service condition for a client.
    - CVE-2021-3733 
  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2021-3737.patch: addresses the potential for the
      urllib http client to enter into an infinite loop and hang on a 100
      Continue response from a malicious server.
    - debian/patches/CVE-2021-3737_test-fix.patch: improves the regression
      test in Lib/test/test_httplib.py
    - CVE-2021-3737

 -- Ian Constantin <ian.constantin@canonical.com>  Thu, 09 Dec 2021 12:04:37 -0500

python3.7 (3.7.5-2~18.04.4) bionic-security; urgency=medium

  * SECURITY UPDATE: Code execution from content received via HTTP
    - debian/patches/CVE-2020-27619.patch: no longer call eval() on
      content received via HTTP in Lib/test/multibytecodec_support.py.
    - CVE-2020-27619
  * SECURITY UPDATE: Buffer overflow
    - debian/patches/CVE-2021-3177.patch: replace snprintf with Python unicode
      formatting in ctypes param reprs in Lib/ctypes/test/test_parameters.py,
      Modules/_ctypes/callproc.c.
    - CVE-2021-3177
  * debian/rules: Disable test_ttk_guionly for armhf, arm6, i386 and s390x.

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Tue, 23 Feb 2021 13:22:40 +0000

python3.7 (3.7.5-2~18.04) bionic-proposed; urgency=medium

  * SRU: LP: #1835738, backport 3.7.5 to 18.04.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Nov 2019 11:50:52 +0100

python3.7 (3.7.5-2) unstable; urgency=medium

  * python3.7-dev: Depend on zlib1g-dev, needed to link as an
    embedded interpreter.

 -- Matthias Klose <doko@debian.org>  Sun, 27 Oct 2019 17:43:29 +0200

python3.7 (3.7.5-1) unstable; urgency=medium

  * Python 3.7.5 release.

 -- Matthias Klose <doko@debian.org>  Tue, 15 Oct 2019 17:24:06 +0200

python3.7 (3.7.3-2~18.04.1) bionic; urgency=medium

  * Rebuild with OpenSSL 1.1.1. LP: #1797386

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Apr 2019 20:16:38 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: python3.7
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
   quilt, autoconf,
   lsb-release, sharutils,
-  libreadline-dev, libncursesw5-dev (>= 5.3), 
+  libreadline-dev, libncursesw5-dev (>= 5.3), g++-8,
   zlib1g-dev, libbz2-dev, liblzma-dev,
   libgdbm-dev, libdb-dev,
   tk-dev, blt-dev (>= 2.4z), libssl-dev,
@@ -124,7 +125,11 @@
 Package: python3.7-dev
 Architecture: any
 Multi-Arch: allowed
-Depends: python3.7 (= ${binary:Version}), libpython3.7-dev (= ${binary:Version}), libpython3.7 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
+Depends: python3.7 (= ${binary:Version}),
+  libpython3.7-dev (= ${binary:Version}),
+  libpython3.7 (= ${binary:Version}),
+  libexpat1-dev, zlib1g-dev,
+  ${shlibs:Depends}, ${misc:Depends}
 Recommends: libc6-dev | libc-dev
 Description: Header files and a static library for Python (v3.7)
  Header files, a static library and development tools for building
